/*
 ķ
                        FLI player for WATCOM C                            
                    Copyright 1997, Kimmel Computer Inc.                   
                   (The screen rutins are in fligraph.asm)                 
 Ľ
*/

#include "fligraph.h"
#include <dos.h>
#include <io.h>
#include <fcntl.h>

typedef unsigned char          BYTE;
typedef unsigned short int     WORD;
typedef unsigned long int      DWORD;

struct fliheader
{
 DWORD size;
 WORD magic; //AF11
 WORD frames;
 WORD xres;  //320
 WORD yres; //200
 WORD flags;
 WORD fenetudjami;
 WORD speed;  //millisecondds to wait
 DWORD next; //0      essetommi
 DWORD frit; //0      essetommi
 BYTE reserved[102];
};   //->128 bytes

struct frameheader
{
 DWORD size;
 WORD magic;  //F1FA
 WORD chunks;
 BYTE reserved[8];
};

struct chunkheader
{
 DWORD size;
 WORD type;
};
//chunk types:
#define FLI_COLOR 11    //paletta tomoritve
#define FLI_LC    12    //sortomoritett
#define FLI_BLACK 13    //ures kep
#define FLI_BRUN  15    //piszok tomoritett
#define FLI_COPY  16    //tomoritetlen (yeah!)

char *fli;
struct frameheader *framepointer;
struct chunkheader *chunkpointer;
struct fliheader *fliheader;

void readfli(char *filename)
{
 int handle;
 DWORD size;

 handle=open(filename, O_RDONLY | O_BINARY);
 read(handle, &size, 4);
 fli=(char *)malloc(size);
 *(DWORD *)fli=size;
 read(handle, (char *) (fli+4), size-4);
 close(handle);
}

void doframe(void)
{
 int chunk;
 char *data;

 (char *)chunkpointer=(char *)framepointer+sizeof(struct frameheader);
 for(chunk=0;chunk<framepointer->chunks;chunk++)
 {
  data=(char *)chunkpointer+sizeof(struct chunkheader);
  switch(chunkpointer->type)
  {
   case FLI_COLOR : flipal(data);
                    break;
   case FLI_LC    : flilc(data);
                    break;
   case FLI_BLACK : clearscreen();
                    break;
   case FLI_BRUN  : flibrun(data);
                    break;
   case FLI_COPY  : flicopy(data);
                    break;
  }
  (char *)chunkpointer+=chunkpointer->size;
 }
}

void main(int argc,char *argv[])
{
 int frame=0;

 if (argc==2) readfli(argv[1]);
 (char *)fliheader=fli;
 if (fliheader->magic!=0x0AF11 || fliheader->xres!=320 || fliheader->yres!=200)
 {
  perror("Ez nem fli!");
 }
 else
 {
  initgraph();
  //playing
  (char *)framepointer=(char *)fliheader+sizeof(struct fliheader);
  while(!kbhit() && frame<fliheader->frames)
  {
   doframe();
   (char*)framepointer+=framepointer->size;
   frame++;
   delay(fliheader->speed*18);
  }
  if (kbhit()) getch();
  closegraph();
 }
 free(fli);
}